<?php
require_once("DBManager.class.php");

class reunion{
	private $idreunion;///
	private $iddoc_curso;	
	private $titulo;
	private $url;
	private $visible;
	private $fechareg;
	private $idpercomparte;
	
	//////////////////////////////////////////
	public function Correlativo()
	{
		$vCorre2 = 1;		
		$vCont = 1;
		$vCeros = "";
		$delta_ceros = 0;
		$AnoSiguiente = 0;
		$AnoActual = 0;
		$fecha = getdate();
		
		$db= new DBManager();
		$rs=$db->execute("SELECT idreunion FROM reunion ORDER BY idreunion;");
		
		//Entra a este bloque si existe algun valor en el campo INroOrd		
		if($rs->lastRow())
		{			
			
		
			$vCorre1 = substr($rs->fields['idreunion'],0,5);//variable que almacena los 4 primeros caracteres de INroOrd
			$vCorre2 = substr($rs->fields['idreunion'],6); //extraigo los ultimos 5 caracteres de INroOrd 			
			
			$vCorre1 = intval($vCorre1); //obtengo el valor entero
			$vCorre2 = intval($vCorre2); //obtengo el valor entero
							
			$vCorre2++;//se incrementa en 1, es decir el correlativo
			
			//verifico si el correlativo llega a ocupar los 5 digitos
		 	$delta_ceros = 6 - strlen($vCorre2);
			
			if( $delta_ceros == 0 )// Si en el codigo  correlativo ya no existen ceros que poner es decir vCorre2 = 10000
			{
				//Si es que he pasado al siguiente año
				$AnoActual = intval($fecha['year']);
				if($AnoActual>$vCorre1)
				{   
					$AnoSiguiente = $vCorre1+=1;
					return $AnoSiguiente."0000001";
				}
				else{

						return ($vCorre1.$vCorre2);
					}			
			}
			
			if( $delta_ceros < 0 /*-1*/)// Si en el codigo correlativo ya no existen ceros que poner y ya llego al limite, en este caso delta_ceros = -1
			{
				$AnoSiguiente = $vCorre1+=1;
				return $AnoSiguiente."0000001";
			}
			
			if( $delta_ceros > 0) // Si en el codigo correlativo existen ceros que poner
			{
			
				//Si es que he pasado al siguiente año
				$AnoActual = intval($fecha['year']);
				if($AnoActual>$vCorre1)
				{   
					$AnoSiguiente = $vCorre1+=1;
					return $AnoSiguiente."0000001";
				}
				else{
						for($i=1; $i<$delta_ceros; $i++)
						{
							$vCont++;//contador de ceros
						}			
						$vCeros=str_pad($vCeros,$vCont,'0',STR_PAD_RIGHT);//rellenar de ceros al lado derecho		
						return($vCorre1.$vCeros.$vCorre2);
					}			
			}			

		}else{ 
				//Caso contrario esta vacio el campo al inicio de las acciones				
				return ($fecha['year']."000000".$vCorre2);				
			 }

		$rs->close();
		$db->closeConnection();//opcional			
	}
	
	///////////////////////////////////////////
	public function Crear($id,$vid,$ti,$url,$de,$es)
	{   
		$resp=false;		
		$db= new DBManager();	
		if($db->_execute("INSERT INTO reunion(idreunion,iddoc_curso,titulo,url,detalle,visible) VALUES('".$id."',".$vid.",'".$ti."','".$url."','".$de."','".$es."')"))   
		{
			$resp=true;
		}
		return $resp;		
	}
	
		
	public function ListarPorPersona($v)
	{
		$vector=null;		
		$db= new DBManager();	
		$rs=$db->execute("select * from reunion where(iddoc_curso =".$v.") order by idreunion desc");
		$num_rows=$rs->getNumOfRows();
		if($num_rows>0)
		{	$row=0;
			$rs->firstRow(); // opcional, pero recomendado
			while (!$rs->EOF) 
			{
   				$vector[$row]=array("idreunion"   => $rs->fields["idreunion"],
									"iddoc_curso" 	    => $rs->fields["iddoc_curso"],
									"titulo"         => $rs->fields["titulo"],
									"url"         => $rs->fields["url"],
									"detalle"         => $rs->fields["detalle"],
									"visible"         => $rs->fields["visible"],
									"fecha"         => $rs->fields["fecha"]);
									
                $row++;
				$rs->nextRow(); // Nota: nextRow() Esta situado al final				
         	}			
        	return $vector;			
		}else return null;
		$rs->close(); 
		$db->closeConnection();//opcional cierra el reunion de la Base de Datos              						
	}
	
	public function ListarPorDocenteVisble($v)
	{
		$vector=null;		
		$db= new DBManager();	
		$rs=$db->execute("select idreunion,iddoc_curso,titulo,url,detalle,visible,date_format(fecha,'%d-%m-%Y') as fecha from reunion where(iddoc_curso =".$v." and visible='SI')");
		$num_rows=$rs->getNumOfRows();
		if($num_rows>0)
		{	$row=0;
			$rs->firstRow(); // opcional, pero recomendado
			while (!$rs->EOF) 
			{
   				$vector[$row]=array("idreunion"   => $rs->fields["idreunion"],
									"iddoc_curso" 	    => $rs->fields["iddoc_curso"],
									"titulo"         => $rs->fields["titulo"],
									"url"         => $rs->fields["url"],
									"detalle"         => $rs->fields["detalle"],
									"visible"         => $rs->fields["visible"],
									"fecha"         => $rs->fields["fecha"]);
									
                $row++;
				$rs->nextRow(); // Nota: nextRow() Esta situado al final				
         	}			
        	return $vector;			
		}else return null;
		$rs->close(); 
		$db->closeConnection();//opcional cierra el enlace de la Base de Datos              						
	}
	
	public function ListaPaginadaPublicos($vcli,$limitInf,$tampag)
	{    /////////////////////////////////////
		$vector=null;		
		$db= new DBManager();		
		$rs=$db->execute("SELECT * FROM reunion WHERE titulo LIKE CONCAT('%','".$vcli."','%') and visible='SI' ORDER BY idreunion desc limit ".$limitInf.",".$tampag.";");			
		$num_rows=$rs->getNumOfRows();
		if($num_rows>0)
		{	$row=0;
			$rs->firstRow(); // opcional, pero recomendado
			while (!$rs->EOF) 
			{    
   				$vector[$row]=array("idreunion"   => $rs->fields["idreunion"],
									"iddoc_curso" 	    => $rs->fields["iddoc_curso"],
									"titulo"         => $rs->fields["titulo"],
									"url"         => $rs->fields["url"],
									"detalle"         => $rs->fields["detalle"],
									"visible"         => $rs->fields["visible"],
									"fecha"         => $rs->fields["fecha"]);
									
                $row++;
				$rs->nextRow(); // Nota: nextRow() Esta situado al final				
         	}			
        	return $vector;			
		}else return null;
		$rs->close(); 
		$db->closeConnection();//opcional cierra el reunion de la Base de Datos              						
	}
	
	public function ListarPorTitulo($v,$idp)
	{
		$vector=null;		
		$db= new DBManager();	
		$rs=$db->execute("select * from reunion where titulo LIKE CONCAT('%','".$v."','%') and iddoc_curso =".$idp." ");
		$num_rows=$rs->getNumOfRows();
		if($num_rows>0)
		{	$row=0;
			$rs->firstRow(); // opcional, pero recomendado
			while (!$rs->EOF) 
			{
   				$vector[$row]=array("idreunion"   => $rs->fields["idreunion"],
									"iddoc_curso" 	    => $rs->fields["iddoc_curso"],
									"titulo"         => $rs->fields["titulo"],
									"url"         => $rs->fields["url"],
									"detalle"         => $rs->fields["detalle"],
									"visible"         => $rs->fields["visible"],
									"fecha"         => $rs->fields["fecha"]);
									
                $row++;
				$rs->nextRow(); // Nota: nextRow() Esta situado al final				
         	}			
        	return $vector;			
		}else return null;
		$rs->close(); 
		$db->closeConnection();//opcional cierra el reunion de la Base de Datos              						
	}
	
	public function ListaPaginada($vcli,$idp,$limitInf,$tampag)
	{    /////////////////////////////////////
		$vector=null;		
		$db= new DBManager();		
		$rs=$db->execute("SELECT * FROM reunion WHERE titulo LIKE CONCAT('%','".$vcli."','%') and iddoc_curso =".$idp."  ORDER BY idreunion desc limit ".$limitInf.",".$tampag.";");			
		$num_rows=$rs->getNumOfRows();
		if($num_rows>0)
		{	$row=0;
			$rs->firstRow(); // opcional, pero recomendado
			while (!$rs->EOF) 
			{    
   				$vector[$row]=array("idreunion"   => $rs->fields["idreunion"],
									"iddoc_curso" 	    => $rs->fields["iddoc_curso"],
									"titulo"         => $rs->fields["titulo"],
									"url"         => $rs->fields["url"],
									"detalle"         => $rs->fields["detalle"],
									"visible"         => $rs->fields["visible"],
									"fecha"         => $rs->fields["fecha"]);
									
                $row++;
				$rs->nextRow(); // Nota: nextRow() Esta situado al final				
         	}			
        	return $vector;			
		}else return null;
		$rs->close(); 
		$db->closeConnection();//opcional cierra el reunion de la Base de Datos              						
	}
		
	public function BuscarPorCodigo($vcod)
	{
		
		$resp=false;
		$num_rows=0;//numero de filas afectada por la consulta
		$db= new DBManager('root','');
		$rs=$db->execute("select * from reunion where(idreunion = '".$vcod."')");
		$num_rows=$rs->getNumOfRows();
		if($num_rows>0)
		{	$resp=true;
			$rs->firstRow(); // opcional, pero recomendado
			while (!$rs->EOF) {
                // Coleccion de campos accesible mediante arrays asociativos también
	                  $this->idreunion=$rs->fields["idreunion"];
				      $this->iddoc_curso=$rs->fields["iddoc_curso"];	
					  $this->titulo=$rs->fields["titulo"];						  				
				      $this->url=$rs->fields["url"];	
					  $this->detalle=$rs->fields["detalle"];		 
				      $this->visible=$rs->fields["visible"];
					  $this->fecha=$rs->fields["fecha"];
 				$rs->nextRow(); // Nota: nextRow() Esta situado al final				
        	}			
		}
		$rs->close(); 
		$db->closeConnection();//opcional cierra el reunion de la Base de Datos              
		return $resp;							
	}
	
	
	public function Actualizar($vi,$ti,$url,$det,$es)			
	{
		$resp=false;		
		$db= new DBManager();
		$vf = implode("-",array_reverse(explode("-",$vf)));	
		if($db->_execute("update reunion set titulo = '".$ti."',url = '".$url."',detalle='".$det."',visible='".$es."' where (idreunion=".$vi.") "))//si es exitosa la consulta			   
		{
		  $resp=true; 
		}	
		return $resp;
	}
	////////////////////////////////*/
	public function ListaTotal()
	{
		$vector=null;
		$db= new DBManager();	
		$rs=$db->execute("select * from reunion order by idreunion desc");
		$num_rows=$rs->getNumOfRows();
		if($num_rows>0)
		{	$row=0;
			$rs->firstRow(); // opcional, pero recomendado
			while (!$rs->EOF) {
                $vector[$row]=array("idreunion"   => $rs->fields["idreunion"],
									"iddoc_curso" 	    => $rs->fields["iddoc_curso"],
									"titulo"         => $rs->fields["titulo"],
									"url"         => $rs->fields["url"],
									"detalle"         => $rs->fields["detalle"],
									"visible"         => $rs->fields["visible"],
									"fecha"         => $rs->fields["fecha"]);
									
                $row++;
				$rs->nextRow(); // Nota: nextRow() Esta situado al final				
        	}			
        	return $vector;			
		}else return null;
		
		$rs->close(); 
		$db->closeConnection();//opcional cierra el reunion de la Base de Datos              						
	}	

	//////////////////////////////
	public function Eliminar($vcod)
	{
		$resp=false;		
		$db= new DBManager();	
		if($db->_execute("DELETE FROM reunion WHERE (idreunion='".$vcod."');"))   
		{
			$resp=true;
		}
		return $resp;		
	}	
	////////////////////////////////////////							
	
	public function getIdenlace(){ return $this->idreunion;}
	public function getIddoc_curso(){ return $this->iddoc_curso;}
	public function getTitulo(){ return $this->titulo;}
	public function getUrl(){ return $this->url;}
	public function getDetalle(){ return $this->detalle;}
	public function getVisible(){ return $this->visible;}
	public function getFecha(){ return $this->fecha;}
}
?>
